#include <iostream>
#include <netcdf>
#include <string>

int main()
{

 	netCDF::NcFile data;
 	data.open("test.nc", netCDF::NcFile::read);
	
	 auto dims = data.getDims();
    for(auto itr : dims)
    {
    	std::cout << itr.first << "\t"<<itr.second.getSize()<< std::endl;
    }

	// const size_t datetime_length = 6;
 // 	const int NLAT = 4;
	// const int NLON = 4;

    const size_t datetime_length = 48;
    const int NLAT = 485;
    const int NLON = 685;

	double lat[NLAT][NLON];
	double lon[NLAT][NLON];

	// read 1 record
	std::vector<size_t> startp, countp;
    startp.push_back(0);
    startp.push_back(0);
    startp.push_back(0);

    countp.push_back(1);
    countp.push_back(NLAT);
    countp.push_back(NLON);

	netCDF::NcVar latVar, lonVar;
	latVar = data.getVar("gridlat_0");
	if(latVar.isNull()) return -1;

	lonVar = data.getVar("gridlon_0");
	if(lonVar.isNull()) return -1;


	latVar.getVar(startp,countp, lat);
	lonVar.getVar(startp,countp, lon);

    for(int y = 0; y < NLAT; y++)
    {
    	for(int x = 0; x < NLON; x++ )
    	{
    		std::cout << "array -- lat=" << lat[y][x] << "\tlon=" << lon[y][x] << std::endl;


            std::vector<size_t> startp_2, countp_2;
            startp_2.push_back(0);
            startp_2.push_back(y);
            startp_2.push_back(x);

            countp_2.push_back(1);
            countp_2.push_back(1);
            countp_2.push_back(1);

            double dlat,dlon;
            latVar.getVar(startp_2,countp_2, &dlat);
            lonVar.getVar(startp_2,countp_2, &dlon);

            std::cout << "index -- lat=" << dlat << "\tlon=" << dlon << std::endl;
     	}
    }

	return 0;
}